package io.github.taha_cmd.api.model;

/**
 * 
 * @author robert.benak
 */
public class SigningRequest {

    private SigningRequestStatus status;
    private SigningRequestWorkflowStatus workflowStatus;

    private String projectId;
    private String projectSlug;
    private String projectName;
    private String artifactConfigurationId;
    private String artifactConfigurationSlug;
    private String artifactConfigurationName;
    private String signingPolicyId;
    private String signingPolicySlug;
    private String signingPolicyName;

    private String unsignedArtifactLink;
    private String signedArtifactLink;

    public SigningRequestStatus getStatus() {
        return status;
    }

    public void setStatus(SigningRequestStatus status) {
        this.status = status;
    }

    public SigningRequestWorkflowStatus getWorkflowStatus() {
        return workflowStatus;
    }

    public void setWorkflowStatus(SigningRequestWorkflowStatus workflowStatus) {
        this.workflowStatus = workflowStatus;
    }

    public String getUnsignedArtifactLink() {
        return unsignedArtifactLink;
    }

    public void setUnsignedArtifactLink(String unsignedArtifactLink) {
        this.unsignedArtifactLink = unsignedArtifactLink;
    }

    public String getSignedArtifactLink() {
        return signedArtifactLink;
    }

    public void setSignedArtifactLink(String signedArtifactLink) {
        this.signedArtifactLink = signedArtifactLink;
    }

    public String getProjectId() {
        return projectId;
    }

    public void setProjectId(String projectId) {
        this.projectId = projectId;
    }

    public String getProjectSlug() {
        return projectSlug;
    }

    public void setProjectSlug(String projectSlug) {
        this.projectSlug = projectSlug;
    }

    public String getProjectName() {
        return projectName;
    }

    public void setProjectName(String projectName) {
        this.projectName = projectName;
    }

    public String getArtifactConfigurationId() {
        return artifactConfigurationId;
    }

    public void setArtifactConfigurationId(String artifactConfigurationId) {
        this.artifactConfigurationId = artifactConfigurationId;
    }

    public String getArtifactConfigurationSlug() {
        return artifactConfigurationSlug;
    }

    public void setArtifactConfigurationSlug(String artifactConfigurationSlug) {
        this.artifactConfigurationSlug = artifactConfigurationSlug;
    }

    public String getArtifactConfigurationName() {
        return artifactConfigurationName;
    }

    public void setArtifactConfigurationName(String artifactConfigurationName) {
        this.artifactConfigurationName = artifactConfigurationName;
    }

    public String getSigningPolicyId() {
        return signingPolicyId;
    }

    public void setSigningPolicyId(String signingPolicyId) {
        this.signingPolicyId = signingPolicyId;
    }

    public String getSigningPolicySlug() {
        return signingPolicySlug;
    }

    public void setSigningPolicySlug(String signingPolicySlug) {
        this.signingPolicySlug = signingPolicySlug;
    }

    public String getSigningPolicyName() {
        return signingPolicyName;
    }

    public void setSigningPolicyName(String signingPolicyName) {
        this.signingPolicyName = signingPolicyName;
    }
    
    public Boolean isFinalStatus() {
        return status == SigningRequestStatus.Canceled
                || status == SigningRequestStatus.Completed
                || status == SigningRequestStatus.Denied
                || status == SigningRequestStatus.Failed;
    }

    @Override
    public String toString() {
        return "SigningRequest{" + "status=" + status + ", isFinalStatus=" + this.isFinalStatus() + ", workflowStatus=" + workflowStatus + ", projectId=" + projectId + ", projectSlug=" + projectSlug + ", projectName=" + projectName + ", artifactConfigurationId=" + artifactConfigurationId + ", artifactConfigurationSlug=" + artifactConfigurationSlug + ", artifactConfigurationName=" + artifactConfigurationName + ", signingPolicyId=" + signingPolicyId + ", signingPolicySlug=" + signingPolicySlug + ", signingPolicyName=" + signingPolicyName + ", unsignedArtifactLink=" + unsignedArtifactLink + ", signedArtifactLink=" + signedArtifactLink + '}';
    }
    
}
